package com.family168.jbpm4book;

import junit.framework.*;

import org.jbpm.api.*;

import org.jbpm.test.*;


public class MigrateTest extends JbpmTestCase {
    public String deployJpdlClasspath(String path) {
        String deploymentDbid = repositoryService.createDeployment()
                                                 .addResourceFromClasspath(path)
                                                 .deploy();

        this.registerDeployment(deploymentDbid);

        return deploymentDbid;
    }

    public void testMigrateNotRunning() {
        this.deployJpdlClasspath("jpdl/a.jpdl.xml");
        this.deployJpdlClasspath("jpdl/b.jpdl.xml");

        ProcessInstance processInstance = executionService
            .startProcessInstanceById("a-1");
        assertTrue(processInstance.isActive("a"));

        String id = processInstance.getId();
        processInstance = executionService.signalExecutionById(id);
        assertTrue(processInstance.isActive("x"));

        //processInstance = executionService.signalExecutionById(id);
        //assertTrue(processInstance.isActive("b"));
        processInstance = executionService.signalExecutionById(id);
        assertTrue(processInstance.isEnded());
    }

    public void testMigrateRunning() {
        this.deployJpdlClasspath("jpdl/a.jpdl.xml");

        ProcessInstance processInstance = executionService
            .startProcessInstanceById("a-1");
        assertTrue(processInstance.isActive("a"));

        String id = processInstance.getId();
        processInstance = executionService.signalExecutionById(id);
        assertTrue(processInstance.isActive("x"));
        this.deployJpdlClasspath("jpdl/b.jpdl.xml");

        processInstance = executionService.signalExecutionById(id);
        assertTrue(processInstance.isActive("b"));
        processInstance = executionService.signalExecutionById(id);
        assertTrue(processInstance.isEnded());
    }
}
